(function(runnable) {
  runnable(window.jQuery, window, document);
}(function($, window, document) {

  $(window).bind('r_library_search', function(event, eventData) {
    var result = {
      items: [],
      count: 0,
      completed: false
    };
    $('#documents li[data-id]').each(function(i, each) {
      result.items[i] = {
        id: $(each).attr('data-id'),
        progressRate: 0,
        count: 0,
        response: ''
      };
    });

    var finder = createFinder(eventData.toLowerCase());
    $.each(result.items, function(i, each) {
      searchDocument(each, finder);
    });

    var monitor = function() {
      for (var i = 0; i < result.items.length; i++) {
        if (!result.items[i].completed) {
          setTimeout(monitor, 200);
          return;
        }
      }
      result.completed = true;
      $(window).trigger('r_library_html_search_result', result);
    };
    monitor();
  });

  var searchDocument = function(item, finder) {
    var contents = window['search_content_' + item.id];
    if (!contents) {
      item.progressRate = 0;
      item.completed = true;
      return;
    }
    var count = contents.length;
    var chapterPosition = 0;
    var searcher = function() {
      var result = finder.search(contents[chapterPosition]);
      item.count += result.count;
      item.response += result.html;
      if (++chapterPosition < count) {
        item.progressRate = 100 * chapterPosition / count;
        setTimeout(searcher, 1);
      } else {
        item.progressRate = 0;
        item.completed = true;
      }
    };
    searcher();
  };

}));