(function(runnable) {
  runnable(window.jQuery, window, document);
}(function($, window, document) {
  var navigator = $('.r_navigator');
  var resultPanel;
  navigator.bind('r_search', function(event, eventData) {
    if (!resultPanel) {
      resultPanel = $('#r_navigation_search');
    }
    var contents = window['search_content_' + $('body').attr('data-book-id')];
    var finder = createFinder(eventData.toLowerCase());

    var count = contents.length;
    var chapterPosition = 0;
    resultPanel.html('<progress id="search_progress" value="0" max="' + count + '"></progress><div class="list"></div>');
    var $progress = $('#search_progress');
    navigator.trigger('r_change_tab', 'r_navigation_search');
    var searcher = function() {
      var result = finder.search(contents[chapterPosition]);
      if (result.count > 0) {
        resultPanel.find('> div').append(result.html);
      }
      if (++chapterPosition < count) {
        $progress.attr('value', chapterPosition);
        setTimeout(searcher, 1);
      } else {
        $progress.remove();
        resultPanel.find('.chapter, .part, .element').each(function(i, each) {
          var $this = $(this);
          var id = $this.attr('id');
          $this.removeAttr('id').attr('data-id', id);
        });
        if (!resultPanel.find('.list *').length) {
          resultPanel.find('.list').html('<div class="warning">' + $(document.body).data('i18n-string-not-found') + '</div>');
        }
      }
    };
    setTimeout(searcher, 1);
  });

}));